function []= PCA_FR(AllImgs)
%% The training part of a typical face recognition algorithm using PCA
% Author: Yanlai Chen
%
% Date: 03/22/2015

% Preprocessing of the images
m = mean(AllImgs,2); 
imgcount = size(AllImgs,2);

SubM = [];
for i=1 : imgcount
    temp = double(AllImgs(:,i)) - m;
    SubM = [SubM temp];
end

%% The Eigen solve
% that is usually needed by all PCA-based algorithms
% V : eigenvector matrix  D : eigenvalue matrix
L = SubM' * SubM;
[V,D]=eig(L);

% Kaiser's rule on finding how many Principal Components to take
KEV = [];
for i = 1 : size(V,2) 
    if( D(i,i) > 1 )
        KEV = [KEV V(:,i)];
    end
end

% building the EigenFaces and preparing for the test phase
eigenfaces = SubM * KEV;

ProjImg = [ ];
for i = 1 : size(eigenfaces,2)
    temp = eigenfaces' * SubM(:,i);
    ProjImg = [ProjImg temp];
end
end